#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <hamsandwich>

new g_LoadMaps[81]
new g_Block

#define PLUGIN    "Block Button in Map"
#define VERSION    "1.0"
#define AUTHOR    "3aTo4Ka"

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)

        RegisterHam(Ham_Use, "func_button", "CheckButton")
}

public plugin_cfg()
{
	get_configsdir(g_LoadMaps, charsmax( g_LoadMaps ))
	format(g_LoadMaps, charsmax( g_LoadMaps ), "%s/block_buttons_maps.cfg", g_LoadMaps) 

	new szParseText[128]
	new szLine, szNum

	for(szLine=0;read_file(g_LoadMaps, szLine, szParseText, charsmax( szParseText ), szNum);szLine++) 
	{
		if(szNum > 0  && szParseText[0] != ';')
		{
			new szMap[32]
			get_mapname(szMap, charsmax( szMap ))

			if(equali(szMap, szParseText))
			{
				g_Block = true
				break
			}
		}
	}
}

public CheckButton(szEnt, szidcaller, szActivator, szUse_type, Float:value)
{
	if (is_user_alive(szActivator) && g_Block &&  get_user_team(szActivator) == 1) 
	{
		new szMapName[32]
		get_mapname(szMapName, charsmax( szMapName ))

		ChatColor(szActivator, "!y[ !g !y]  !g%s !y !t!", szMapName)
		return HAM_SUPERCEDE       
	}     
	return HAM_IGNORED     
}

stock ChatColor(const id, const input[], any:...)
{
	new count = 1, players[32]
	static msg[191]
	vformat(msg, 190, input, 3)
	
	replace_all(msg, 190, "!g", "^4")
	replace_all(msg, 190, "!y", "^1")
	replace_all(msg, 190, "!t", "^3")
	
	if (id) players[0] = id; else get_players(players, count, "ch")
	{
		for (new i = 0; i < count; i++)
		{
			if (is_user_connected(players[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i]);
				write_byte(players[i]);
				write_string(msg);
				message_end();
			}
		}
	}
}